<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® NonCommercial, 7.6 of lundi 3 mars 2008 on samedi 31 août 2013 at 11:43:29</time-stamp>
<!-- Package JLB* -->


<component-property>
<name>JLB</name> <type>package</type>
<property>packageName</property> <value>'JLB'</value>
</component-property>

<component-property>
<name>JLB</name> <type>package</type>
<property>parcelName</property> <value>'JLB'</value>
</component-property>

<name-space>
<name>JLB</name>
<environment>CormasNS.Models</environment>
<private>false</private>
<imports>
			private Smalltalk.*
			private CormasNS.Kernel.*
			</imports>
<category>JLBCategory</category>
<attributes>
<package>JLB</package>
</attributes>
</name-space>

<class>
<name>Community</name>
<environment>CormasNS.Models.JLB</environment>
<super>CormasNS.Kernel.Group</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>threshold forests </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>JLBCategory</category>
<attributes>
<package>JLB</package>
</attributes>
</class>

<class>
<name>Strategy</name>
<environment>CormasNS.Models.JLB</environment>
<super>CormasNS.Kernel.PassiveObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>holder </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>JLBCategory</category>
<attributes>
<package>JLB</package>
</attributes>
</class>

<class>
<name>CollectiveStrategy</name>
<environment>CormasNS.Models.JLB</environment>
<super>CormasNS.Models.JLB.Strategy</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>JLBCategory</category>
<attributes>
<package>JLB</package>
</attributes>
</class>

<class>
<name>IndividualStrategy</name>
<environment>CormasNS.Models.JLB</environment>
<super>CormasNS.Models.JLB.Strategy</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>JLBCategory</category>
<attributes>
<package>JLB</package>
</attributes>
</class>

<class>
<name>Cell</name>
<environment>CormasNS.Models.JLB</environment>
<super>CormasNS.Kernel.SpatialEntityElement</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>forest mark </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>JLBCategory</category>
<attributes>
<package>JLB</package>
</attributes>
</class>

<class>
<name>JLB</name>
<environment>CormasNS.Models.JLB</environment>
<super>CormasNS.Kernel.CormasModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>theCells theWoodLands theShepherds theStrategys theCommunitys theIntermediateStrategys theIndividualStrategys theCollectiveStrategys nbShepherds periodicity </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>JLBCategory</category>
<attributes>
<package>JLB</package>
</attributes>
</class>

<class>
<name>Shepherd</name>
<environment>CormasNS.Models.JLB</environment>
<super>CormasNS.Kernel.AgentLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>community currentStrategy threshold forestMemory </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>JLBCategory</category>
<attributes>
<package>JLB</package>
</attributes>
</class>

<class>
<name>IntermediateStrategy</name>
<environment>CormasNS.Models.JLB</environment>
<super>CormasNS.Models.JLB.Strategy</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>JLBCategory</category>
<attributes>
<package>JLB</package>
</attributes>
</class>

<class>
<name>WoodLand</name>
<environment>CormasNS.Models.JLB</environment>
<super>CormasNS.Kernel.SpatialEntityAggregate</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>JLBCategory</category>
<attributes>
<package>JLB</package>
</attributes>
</class>


<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.JLB.Community</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>JLB</package>
</attributes>
</shared-variable>



<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.JLB.CollectiveStrategy</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>JLB</package>
</attributes>
</shared-variable>




<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.JLB.IndividualStrategy</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>JLB</package>
</attributes>
</shared-variable>



<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.JLB.IntermediateStrategy</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>JLB</package>
</attributes>
</shared-variable>



<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.JLB.Strategy</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>JLB</package>
</attributes>
</shared-variable>



<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.JLB.WoodLand</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>JLB</package>
</attributes>
</shared-variable>



<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.JLB.Shepherd</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>JLB</package>
</attributes>
</shared-variable>



<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.JLB.Cell</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>JLB</package>
</attributes>
</shared-variable>



<methods>
<class-id>CormasNS.Models.JLB.Community class</class-id> <category>- default value</category>

<body package="JLB" selector="threshold_default">threshold_default 
	"Return the default value of threshold attribute"	
	^0</body>

<body package="JLB" selector="forests_default">forests_default 
	"Return the default value of forests attribute"	
	^nil</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.Community</class-id> <category>control</category>

<body package="JLB" selector="markForests">markForests
	
	self forests do:
			[:aForest | 
			aForest components size &lt; self threshold
				ifTrue: [aForest components do: [:aCell | aCell mark: aForest components size]]
				ifFalse: [aForest components do: [:aCell | aCell mark: 0]]]</body>

<body package="JLB" selector="updateThreshold">updateThreshold
	| sumOfThresolds |
	self components isEmpty ifTrue:[^0].
	sumOfThresolds := self components inject: 0 into: [:cumul :a | cumul + a threshold].
	self threshold: sumOfThresolds / self components size</body>

<body package="JLB" selector="step">step
	"Update its thresshold then mark the forests. Called every 10 years"
	self updateThreshold.
	self markForests</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.Community</class-id> <category>accessing</category>

<body package="JLB" selector="threshold:">threshold: k
	threshold := k</body>

<body package="JLB" selector="threshold">threshold
	"Getter accessor with default value = 0 "
	^threshold ifNil:[threshold := 0]</body>

<body package="JLB" selector="forests:">forests: x
	forests := x</body>

<body package="JLB" selector="forests">forests
	^forests</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.JLB class</class-id> <category>description</category>

<body package="JLB" selector="versionComments">versionComments
^ ' 

 --------------------- JLB.pcl --------------------- Date: 2013.7.9 - 7:47:38
Compatible to Cormas 2013
 *** Developer:   ***'	</body>

<body package="JLB" selector="currentDeveloperName">currentDeveloperName
^ ' '	</body>

<body package="JLB" selector="cormasCompatibleVersion">cormasCompatibleVersion
^ #(2013 8 31 10 25 51)</body>

<body package="JLB" selector="version">version
^ 'JLB.st'	</body>

<body package="JLB" selector="howToRunIt">howToRunIt
| txt |
	txt := 'Just select the init and step methods' asText emphasizeAllWith: #(#bold).
	ComposedTextView open: txt asValue
		label: 'How to run ' , self name , '     step-by-step instructions'
		icon: (Icon constantNamed: #workspace)
		extent: 200 @ 50</body>

<body package="JLB" selector="vwCompatibleVersion">vwCompatibleVersion
^ '7.6'	</body>

<body package="JLB" selector="aboutIt">aboutIt
| txt |
	txt := 
'This model has been rewrited from the article of J.L. Bonnefoy*.
Please visite the Cormas web site :  http://cormas.cirad.fr/en/applica/jlb.htm

* Bonnefoy, J.-L., Le Page, C., Rouchier, J. et Bousquet, F., 2000. Modelling spatial practices and social representations of spaceModel using multi-agents. p. 155-168 in: G. Ballot et G. Weisbuch (eds), Application of simulation to social science. Hermès, Paris


' asText.
	ComposedTextView open: txt asValue
		label: 'About ' , self name
		icon: (Icon constantNamed: #workspace)
		extent: 800 @ 150</body>

<body package="JLB" selector="lastUpdate">lastUpdate
^ 'samedi 31 août 2013'	</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.JLB class</class-id> <category>- probes</category>

<body package="JLB" selector="colorOfProbe_woodLandsAverageSize">colorOfProbe_woodLandsAverageSize
  ^ (ColorValue red: 1.0 green: 0.125015 blue: 1.0)</body>

<body package="JLB" selector="colorOfProbe_nbForestCells">colorOfProbe_nbForestCells
  ^ (ColorValue red: 0.0 green: 0.870345 blue: 0.0)</body>

<body package="JLB" selector="colorOfProbe_nbWoodLands">colorOfProbe_nbWoodLands
  ^ (ColorValue red: 0.870345 green: 0.109144 blue: 0.109144)</body>

<body package="JLB" selector="colorOfProbe_woodLandsSizeOnForestCells">colorOfProbe_woodLandsSizeOnForestCells
  ^ ColorValue springGreen</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.JLB class</class-id> <category>- default value</category>

<body package="JLB" selector="nbShepherds_default">nbShepherds_default 
	"Return the default value of nbShepherds attribute"	
	^40</body>

<body package="JLB" selector="theStrategys_default">theStrategys_default 
	"Return the default value of theStrategys attribute"	
	^nil</body>

<body package="JLB" selector="periodicity_default">periodicity_default 
	"Return the default value of periodicity attribute"	
	^10</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.JLB</class-id> <category>probes</category>

<body package="JLB" selector="woodLandsSizeOnForestCells">woodLandsSizeOnForestCells
	"modify this instruction to calculate the number to be recorded"
	
	^self nbForestCells = 0
		ifTrue: [0]
		ifFalse:
			[self woodLandsAverageSize * self nbWoodLands / self nbForestCells]</body>

<body package="JLB" selector="nbWoodLands">nbWoodLands
"modify this instruction to calculate the number to be recorded"
^self theWoodLands size</body>

<body package="JLB" selector="nbForestCells">nbForestCells
"modify this instruction to calculate the number to be recorded"
^(self theCells select:[:c| c forest]) size</body>

<body package="JLB" selector="woodLandsAverageSize">woodLandsAverageSize
"modify this instruction to calculate the number to be recorded"
^Cormas average: (self theWoodLands collect: [: agg | agg size])</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.JLB</class-id> <category>accessing</category>

<body package="JLB" selector="theWoodLands:">theWoodLands: x
theWoodLands := x</body>

<body package="JLB" selector="theShepherds:">theShepherds: x
theShepherds := x</body>

<body package="JLB" selector="theCells:">theCells: x
theCells := x</body>

<body package="JLB" selector="theCommunity">theCommunity
	^theCommunitys first</body>

<body package="JLB" selector="theCommunitys:">theCommunitys: x
theCommunitys := x</body>

<body package="JLB" selector="theCommunitys">theCommunitys
^theCommunitys ifNil:[theCommunitys := IndexedSet new]</body>

<body package="JLB" selector="theIndividualStrategys:">theIndividualStrategys: x
theIndividualStrategys := x</body>

<body package="JLB" selector="theCollectiveStrategys">theCollectiveStrategys
^theCollectiveStrategys ifNil:[theCollectiveStrategys := IndexedSet new]</body>

<body package="JLB" selector="periodicity">periodicity
	"Getter accessor with default value = 10 "
	^periodicity ifNil:[periodicity := 10]</body>

<body package="JLB" selector="theStrategys:">theStrategys: x
theStrategys := x</body>

<body package="JLB" selector="theCells">theCells
^theCells ifNil:[theCells := IndexedSet new]</body>

<body package="JLB" selector="theShepherds">theShepherds
^theShepherds ifNil:[theShepherds := IndexedSet new]</body>

<body package="JLB" selector="nbShepherds:">nbShepherds: x
	nbShepherds := x</body>

<body package="JLB" selector="theStrategys">theStrategys
^theStrategys</body>

<body package="JLB" selector="theIntermediateStrategys:">theIntermediateStrategys: x
theIntermediateStrategys := x</body>

<body package="JLB" selector="theCollectiveStrategys:">theCollectiveStrategys: x
theCollectiveStrategys := x</body>

<body package="JLB" selector="theWoodLands">theWoodLands
^theWoodLands ifNil:[theWoodLands := IndexedSet new]</body>

<body package="JLB" selector="theIndividualStrategys">theIndividualStrategys
^theIndividualStrategys ifNil:[theIndividualStrategys := IndexedSet new]</body>

<body package="JLB" selector="nbShepherds">nbShepherds
	"Getter accessor with default value = 40 "
	^nbShepherds ifNil:[nbShepherds := 40]</body>

<body package="JLB" selector="periodicity:">periodicity: x
	periodicity := x</body>

<body package="JLB" selector="theIntermediateStrategys">theIntermediateStrategys
^theIntermediateStrategys ifNil:[theIntermediateStrategys := IndexedSet new]</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.JLB</class-id> <category>instance-creation</category>

<body package="JLB" selector="buildForests">buildForests

	self spaceModel
		setAggregatesFrom: Cell
		verifying: [:c | c forest]
		into: WoodLand.</body>

<body package="JLB" selector="initAgents">initAgents
	self newEntity: Community. 
	self theCommunity forests: self theWoodLands.
	(self createN: self nbShepherds randomlyLocatedAgents: Shepherd)
		do: 
			[: s | 
			s updateStrategy.
			s community: self theCommunity].
	self theCommunity addComponents: self theShepherds.</body>

<body package="JLB" selector="createForests">createForests
	| seed |
	10 timesRepeat: 
			[seed := Cormas selectRandomlyFrom: (self theCells select: [:c | c forest not]).
			seed forest: true.
			(seed recursiveNeighbourhood: (Cormas randomFrom: 1 to: 5))
				do: [:a | a forest: true]]</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.JLB</class-id> <category>init</category>

<body package="JLB" selector="init">init

	self spaceModel loadEnvironmentFromFile: 'test.env'.
	self buildForests.
	self initAgents</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.JLB</class-id> <category>control</category>

<body package="JLB" selector="step:">step: t 
	self  stepEntities: Shepherd.
	self ask: Cell toDo: #forestRecover.
	(self testPeriodicity:  self periodicity)
		ifTrue: 
			[self buildForests.
			self ask: Shepherd toDo: #updateThreshold: with: self periodicity.
			self  stepEntities: Community].</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.Shepherd class</class-id> <category>image</category>

<body package="JLB" selector="defaultImage">defaultImage
"defaultImage adapted for Cormas versions previous to 2010. Returns a copy of the POV image stored in the povDict of the class at a specifed symbol key"
^((self povDict keys includes: #Shepherd) ifTrue:[self povDict at:#Shepherd] ifFalse:[super defaultImage]) copy</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.Shepherd class</class-id> <category>- default value</category>

<body package="JLB" selector="currentStrategy_default">currentStrategy_default 
	"Return the default value of currentStrategy attribute"	
	^nil</body>

<body package="JLB" selector="community_default">community_default 
	"Return the default value of community attribute"	
	^nil</body>

<body package="JLB" selector="threshold_default">threshold_default 
	"Return the default value of threshold attribute"	
	^0</body>

<body package="JLB" selector="forestMemory_default">forestMemory_default 
	"Return the default value of forestMemory attribute"	
	^0</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.Shepherd class</class-id> <category>pov symbols</category>

<body package="JLB" selector="VectorialPOV_Shepherd">VectorialPOV_Shepherd
"Returns an array containing the settings of a Situated entity vectorial pov symbol in the following order:
(color red) (color green) (color blue) (lineColor red) (lineColor green) (lineColor blue) lineWidth sizeratio position (array of outline vertices)"
^#(0.0 0.0 0.0 0.0 0.0 0.0 1 1.4 #center #(0@-11 11@0 0@11 -11@0 0@-11))</body>

<body package="JLB" selector="VectorialPOV_IndividualStrategy">VectorialPOV_IndividualStrategy
"Returns an array containing the settings of a Situated entity vectorial pov symbol in the following order:
(color red) (color green) (color blue) (lineColor red) (lineColor green) (lineColor blue) lineWidth sizeratio position (array of outline vertices)"
^#(1.0 0.0 0.0 0.0 0.0 0.0 1 1.8 #center #(0@-11 11@0 0@11 -11@0 0@-11))</body>

<body package="JLB" selector="VectorialPOV_IntermediateStrategy">VectorialPOV_IntermediateStrategy
"Returns an array containing the settings of a Situated entity vectorial pov symbol in the following order:
(color red) (color green) (color blue) (lineColor red) (lineColor green) (lineColor blue) lineWidth sizeratio position (array of outline vertices)"
^#(1.0 0.0 1.0 0.0 0.0 0.0 1 1.8 #center #(0@-11 11@0 0@11 -11@0 0@-11))</body>

<body package="JLB" selector="VectorialPOV_CollectiveStrategy">VectorialPOV_CollectiveStrategy
"Returns an array containing the settings of a Situated entity vectorial pov symbol in the following order:
(color red) (color green) (color blue) (lineColor red) (lineColor green) (lineColor blue) lineWidth sizeratio position (array of outline vertices)"
^#(0.0 0.0 1.0 0.0 0.0 0.0 1 1.7 #center #(0@-11 11@0 0@11 -11@0 0@-11))</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.Shepherd</class-id> <category>action</category>

<body package="JLB" selector="cutForest">cutForest
	self patch forest: false</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.Shepherd</class-id> <category>accessing</category>

<body package="JLB" selector="currentStrategy:">currentStrategy: anObject
	"Setter accessor of attribute currentStrategy "
	currentStrategy = anObject ifTrue:[^nil].   "for optimization"
	currentStrategy := anObject.
	self changed</body>

<body package="JLB" selector="forestMemory:">forestMemory: x 
	forestMemory := x</body>

<body package="JLB" selector="community:">community: v
	community := v</body>

<body package="JLB" selector="community">community
	^community</body>

<body package="JLB" selector="knownStrategies">knownStrategies
	^Strategy subclasses</body>

<body package="JLB" selector="forestMemory">forestMemory
	"Getter accessor with default value = 0 "
	^forestMemory ifNil:[forestMemory := 0]</body>

<body package="JLB" selector="threshold:">threshold: x 
	threshold := x</body>

<body package="JLB" selector="currentStrategy">currentStrategy
	^currentStrategy</body>

<body package="JLB" selector="threshold">threshold
	"Getter accessor with default value = 0 "
	^threshold ifNil:[threshold := 0]</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.Shepherd</class-id> <category>control</category>

<body package="JLB" selector="updateForestMemory">updateForestMemory
	(self visibleCells contains: [:c | c forest])
		ifTrue: [self forestMemory: self forestMemory + 1]</body>

<body package="JLB" selector="updateThreshold:">updateThreshold: periodicity
	self threshold: periodicity - self forestMemory.
	self forestMemory: 0</body>

<body package="JLB" selector="step">step
	self updateForestMemory.
	self currentStrategy process: self visibleCells</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.Shepherd</class-id> <category>perception</category>

<body package="JLB" selector="visibleCells">visibleCells
	^self perception: 1</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.Shepherd</class-id> <category>pov</category>

<body package="JLB" selector="pov">pov
	^self currentStrategy class name</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.Shepherd</class-id> <category>init</category>

<body package="JLB" selector="updateStrategy">updateStrategy
	
	self currentStrategy: (Cormas selectRandomlyFrom: self knownStrategies) new.
	self currentStrategy holder: self</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.Strategy</class-id> <category>control</category>

<body package="JLB" selector="decideActions:">decideActions: targetCells 
	targetCells isEmpty
		ifTrue: [self holder randomWalk]
		ifFalse: 
			[self holder moveTo: (Cormas selectRandomlyFrom: targetCells).
			self holder cutForest]</body>

<body package="JLB" selector="determineTargets:">determineTargets: visibleCells
"^ &lt;OrderedCollection of: Cell&gt;
visibleCells = &lt;OrderedCollection of: Cell&gt;"
	self subclassResponsibility</body>

<body package="JLB" selector="process:">process: perceiveCells
| targets |
	targets := self determineTargets: perceiveCells.
	self decideActions: targets</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.Strategy</class-id> <category>accessing</category>

<body package="JLB" selector="holder">holder
	^holder</body>

<body package="JLB" selector="holder:">holder: aShepherd
	holder := aShepherd</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.IntermediateStrategy class</class-id> <category>image</category>

<body package="JLB" selector="defaultImage">defaultImage
"defaultImage adapted for Cormas versions previous to 2010. Returns a copy of the POV image stored in the povDict of the class at a specifed symbol key"
^((self povDict keys includes: #IntermediateStrategy) ifTrue:[self povDict at:#IntermediateStrategy] ifFalse:[super defaultImage]) copy</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.IntermediateStrategy class</class-id> <category>- default value</category>

<body package="JLB" selector="holder_default">holder_default 
	"Return the default value of holder attribute"	
	^nil</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.IntermediateStrategy</class-id> <category>action</category>

<body package="JLB" selector="determineTargets:">determineTargets: visibleCells 
	"^ &lt;OrderedCollection of: Cell&gt; 
	visibleCells = &lt;OrderedCollection of: Cell&gt;"

	| collec |
	collec := visibleCells select: [:aCell | aCell mark = 0].
	collec isEmpty ifTrue: [collec := visibleCells select: [:aCell | aCell mark &gt;= (self holder threshold + self holder community threshold / 2)]].
	^collec</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.Cell class</class-id> <category>pov symbols</category>

<body package="JLB" selector="SpatialEntityPOV_grazing">SpatialEntityPOV_grazing
"Returns an array containing the settings of a Spatial entity pov symbol in the following order:
(color red) (color green) (color blue)"
^Array with: 0.830057 with: 0.830057 with: 0.0</body>

<body package="JLB" selector="SpatialEntityPOV_forest">SpatialEntityPOV_forest
"Returns an array containing the settings of a Spatial entity pov symbol in the following order:
(color red) (color green) (color blue)"
^Array with: 0.0 with: 0.670004 with: 0.0</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.Cell class</class-id> <category>- default value</category>

<body package="JLB" selector="forest_default">forest_default 
	"Return the default value of forest attribute"	
	^nil</body>

<body package="JLB" selector="mark_default">mark_default 
	"Return the default value of mark attribute"	
	^0</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.Cell class</class-id> <category>constants</category>

<body package="JLB" selector="proba">proba
	^0.0025</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.Cell</class-id> <category>accessing</category>

<body package="JLB" selector="mark">mark
	"Getter accessor with default value = 0 "
	mark isNil ifTrue:[mark := 0]. 
	
	^mark</body>

<body package="JLB" selector="forest">forest
	^forest</body>

<body package="JLB" selector="forest:">forest: x
	forest := x.
	self defineVisualState; show</body>

<body package="JLB" selector="mark:">mark: anObject 
	mark := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.Cell</class-id> <category>pov</category>

<body package="JLB" selector="pov">pov
	(self forest notNil and: [self forest])
		ifTrue: [^#forest]
		ifFalse: [^#grazing]</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.Cell</class-id> <category>dynamics</category>

<body package="JLB" selector="forestRecover">forestRecover
	| nbFN |
	self forest
		ifFalse: 
			[nbFN := (self neighbourhood select: [:c | c forest]) size.
			Cormas random &lt; (Cell proba * nbFN) ifTrue: [self forest: true]]</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.WoodLand class</class-id> <category>pov symbols</category>

<body package="JLB" selector="SpatialEntityPOV_forest">SpatialEntityPOV_forest
"Returns an array containing the settings of a Spatial entity pov symbol in the following order:
(color red) (color green) (color blue)"
^Array with: 0.0 with: 0.529972 with: 0.0</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.WoodLand</class-id> <category>pov</category>

<body package="JLB" selector="pov">pov
 ^#forest</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.IndividualStrategy class</class-id> <category>image</category>

<body package="JLB" selector="defaultImage">defaultImage
"defaultImage adapted for Cormas versions previous to 2010. Returns a copy of the POV image stored in the povDict of the class at a specifed symbol key"
^((self povDict keys includes: #IndividualStrategy) ifTrue:[self povDict at:#IndividualStrategy] ifFalse:[super defaultImage]) copy</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.IndividualStrategy class</class-id> <category>- default value</category>

<body package="JLB" selector="holder_default">holder_default 
	"Return the default value of holder attribute"	
	^nil</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.IndividualStrategy</class-id> <category>action</category>

<body package="JLB" selector="determineTargets:">determineTargets: visibleCells 
	"^ &lt;OrderedCollection of: Cell&gt; 
	visibleCells = &lt;OrderedCollection of: Cell&gt;"

	| collec |
	collec := visibleCells select: [:aCell | aCell mark = 0].
	collec isEmpty ifTrue: [collec := visibleCells select: [:aCell | aCell mark &gt;= self holder threshold]].
	^collec</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.CollectiveStrategy class</class-id> <category>image</category>

<body package="JLB" selector="defaultImage">defaultImage
"defaultImage adapted for Cormas versions previous to 2010. Returns a copy of the POV image stored in the povDict of the class at a specifed symbol key"
^((self povDict keys includes: #CollectiveStrategy) ifTrue:[self povDict at:#CollectiveStrategy] ifFalse:[super defaultImage]) copy</body>
</methods>

<methods>
<class-id>CormasNS.Models.JLB.CollectiveStrategy class</class-id> <category>- default value</category>

<body package="JLB" selector="holder_default">holder_default 
	"Return the default value of holder attribute"	
	^nil</body>
</methods>


<methods>
<class-id>CormasNS.Models.JLB.CollectiveStrategy</class-id> <category>action</category>

<body package="JLB" selector="determineTargets:">determineTargets: visibleCells
"^ &lt;OrderedCollection of: Cell&gt;
visibleCells = &lt;OrderedCollection of: Cell&gt;"

	^visibleCells select: [:aCell | aCell mark = 0]</body>
</methods>




</st-source>
